Index: /trunk/library/ckeditor/plugins/expresso/plugin.js
===================================================================
--- /trunk/library/ckeditor/plugins/expresso/plugin.js	(revision 5081)
+++ /trunk/library/ckeditor/plugins/expresso/plugin.js	(revision 5604)
@@ -9,5 +9,5 @@
             {
                 label: 'Adicionar Imagem',
-                command: 'expAddImageCMD',
+                command: 'imgDialog',
                 icon: CKEDITOR.plugins.getPath('expresso') + 'img/Image.gif'
             });
@@ -43,9 +43,144 @@
         });
         
+        
+        editor.addCommand( 'imgDialog',new CKEDITOR.dialogCommand( 'imgDialog' ) );
+
+		if ( editor.contextMenu )
+		{
+			editor.addMenuGroup( 'mygroup', 10 );
+			editor.addMenuItem( 'My Dialog',
+			{
+				label : 'Open dialog',
+				command : 'imgDialog',
+				group : 'mygroup'
+			});
+			editor.contextMenu.addListener( function( element )
+			{
+ 				return {'My Dialog' : CKEDITOR.TRISTATE_OFF};
+			});
+		}
+                
+		CKEDITOR.dialog.add( 'imgDialog', function( api )
+		{
+                        var ID = currentTab;
+			// CKEDITOR.dialog.definition
+			var dialogDefinition =
+			{
+				
+                                title : 'Inserir Imagem',
+				minWidth : 400,
+				minHeight : 70,
+				contents : [
+					{
+						id : 'tab1',
+						label : 'Label',
+						title : 'Title',
+						expand : true,
+						padding : 0,
+						elements :
+						[
+							{
+								type : 'html',
+								html :  '<form id="fileupload_img'+ID+'" class="fileupload" action="mailAttachment:img" method="POST">    <input type="file" name="files[]" multiple="" onclick="bindFileUpload();" style="margin-left:10px"></form>' 
+							}
+						]
+					}
+				],
+				buttons : [ CKEDITOR.dialog.cancelButton]
+				
+			};
+                        	
+			return dialogDefinition;
+		} );
+	
          
-        var cmd = editor.addCommand('expAddImageCMD',  { exec: showexpIncImageDialog });
+
     }
 });
-function showexpIncImageDialog(e) {
-   RichTextEditor.createImage();
+function bindFileUpload(e) {
+        var ID = currentTab;
+        var newImageId = new Date().getTime();
+        var fileUploadIMG = $('#fileupload_img'+ID);
+        var fileUploadMSG = $('#fileupload_msg'+ID);
+        var maxAttachmentSise = (preferences.max_attachment_size !== "" && preferences.max_attachment_size != 0) ? (parseInt(preferences.max_attachment_size.replace('M', '')) * 1048576 ) : false;
+	fileUploadIMG.fileupload({
+		sequentialUploads: true,
+		add: function (e, data) {
+     
+			if(!maxAttachmentSise || data.files[0].size < maxAttachmentSise) {
+				setTimeout(function() {
+                                        $('#attDisposition'+ID).val('embedded');
+					data.submit();
+				}, 5000);
+			}
+                        
+		},
+		change: function (e, data) {
+			$.each(data.files, function (index, file) {	
+				var attach = {};
+				attach.fullFileName = file.name;
+				attach.fileName = file.name;
+				if(file.name.length > 10)
+					attach.fileName = file.name.substr(0, 18) + "..." + file.name.substr(file.name.length-9, file.name.length);
+				attach.fileSize = formatBytes(file.size);
+				if(maxAttachmentSise && file.size > maxAttachmentSise)
+					attach.error = 'Tamanho de arquivo nao permitido!!'
+								
+				fileUploadMSG.find('.attachments-list').append(DataLayer.render("../prototype/modules/mail/templates/attachment_add_itemlist.ejs", {file : attach}));
+
+				if(!maxAttachmentSise || file.size < maxAttachmentSise){
+					fileUploadMSG.find(' .fileinput-button.new').append(data.fileInput[0]).removeClass('new');
+					fileUploadMSG.find(' .attachments-list').find('[type=file]').addClass('hidden');
+					
+				}else
+					fileUploadMSG.find(' .fileinput-button.new').removeClass('new');
+				
+				
+				fileUploadMSG.find(' .attachments-list').find('.button.close').button({
+					icons: {
+						primary: "ui-icon-close"
+					},
+					text: false
+				}).click(function(){
+					var idAttach = $(this).parent().find('input[name="fileId[]"]').val();
+			
+                                        var content_body = RichTextEditor.getData('body_'+ID);
+                                        var imagens = content_body.match(/<img[^>]*>/g);
+       
+                                        if(imagens != null)
+                                            for (var x = 0; x < imagens.length; x++)
+                                                if(imagens[x].indexOf('src="../prototype/getArchive.php?mailAttachment='+idAttach+'"') !== -1)
+                                                        content_body = content_body.replace(imagens[x],'');
+         
+                                        RichTextEditor.setData('body_'+ID,content_body);   
+                                       	
+                                        $('.attachments-list').find('input[value="'+idAttach+'"]').remove();
+                                        delAttachment(ID, idAttach);
+					$(this).parent().remove();
+				});
+                                
+                                CKEDITOR.instances['body_'+ID].insertHtml('<img id="'+newImageId+'" src=""/>');
+
+		});
+                
+                    CKEDITOR.dialog.getCurrent().hide();
+                },
+		done: function(e, data){
+			if(!!data.result && data.result != "[]"){
+				var newAttach = jQuery.parseJSON(data.result);
+				fileUploadMSG.find('.in-progress:first').parents('p').append('<input type="hidden" name="fileId[]" value="'+newAttach['mailAttachment'][0][0].id+'"/>');
+                                addAttachment(ID,newAttach['mailAttachment'][0][0].id);
+                                var content_body  = RichTextEditor.getData('body_'+ID);
+                                var rex = new RegExp('<img id="'+newImageId+'" src="" [^\/>]*\/>', 'i'); 
+                                var newImg = '<img src="../prototype/getArchive.php?mailAttachment='+newAttach['mailAttachment'][0][0].id+'" />'; 
+                                content_body = content_body.replace(rex,newImg); 
+                                RichTextEditor.setData('body_'+ID,content_body); 
+      
+			}else {
+				fileUploadMSG.find(' .progress.on-complete:first').removeClass('on-complete').parents('p').find('.status-upload').addClass('ui-icon ui-icon-cancel');
+			}
+			fileUploadMSG.find('.in-progress:first').remove();
+                    
+		}
+	});
 }
Index: /trunk/library/PEAR/PEAR.php
===================================================================
--- /trunk/library/PEAR/PEAR.php	(revision 5146)
+++ /trunk/library/PEAR/PEAR.php	(revision 5604)
@@ -728,5 +728,5 @@
 
 if (PEAR_ZE2) {
-    include_once 'PEAR5.php';
+    include_once dirname(__FILE__).'/PEAR5.php';
 }
 
Index: /trunk/library/mime/mime.php
===================================================================
--- /trunk/library/mime/mime.php	(revision 5316)
+++ /trunk/library/mime/mime.php	(revision 5604)
@@ -873,13 +873,9 @@
                 $rep[] = '\1\2=\3cid:' . $value['cid'] .'\3';
                 $rep[] = 'url(\1cid:' . $value['cid'] . '\1)';
-
+                             
                 $this->_htmlbody = preg_replace($regex, $rep, $this->_htmlbody);
                 $this->_html_images[$key]['name']
                     = $this->_basename($this->_html_images[$key]['name']);
-              
-                //Alteração para o Expresso.
-                //Ver https://dev.prognus.com.br/expresso/ticket/1256
-                $this->_htmlbody = str_replace("src=\"cid:".substr($value['cid'], 0, strpos($value['cid'], '@'))."\"", "src=\"cid:".$value['cid']."\"", $this->_htmlbody);
-
+                            
             }
         }
Index: /trunk/prototype/services/ImapServiceAdapter.php
===================================================================
--- /trunk/prototype/services/ImapServiceAdapter.php	(revision 5586)
+++ /trunk/prototype/services/ImapServiceAdapter.php	(revision 5604)
@@ -333,5 +333,5 @@
 
     public function create( $URI, $data)
-    {
+    {               
 		switch( $URI['concept'] )
 		{
@@ -364,4 +364,90 @@
 				}
 				return array ();
+			}
+                        case 'message':
+			{
+				$GLOBALS['phpgw_info']['flags'] = array( 'noheader' => true, 'nonavbar' => true,'currentapp' => 'expressoMail1_2','enable_nextmatchs_class' => True );
+                                $return = array();
+
+                                require_once dirname(__FILE__) . '/../../services/class.servicelocator.php';
+                                $mailService = ServiceLocator::getService('mail');
+
+                                $msg_uid = $data['msg_id'];
+                                $body = $data['body'];
+                                $body = str_replace("%nbsp;","&nbsp;",$body);
+                                $body = preg_replace("/\n/"," ",$body);
+                                $body = preg_replace("/\r/","" ,$body);
+                                $body = html_entity_decode ( $body, ENT_QUOTES , 'ISO-8859-1' );					
+
+                                $folder = mb_convert_encoding($data['folder'], "UTF7-IMAP","ISO-8859-1, UTF-8");
+                                $folder = @eregi_replace("INBOX[/.]", "INBOX".$this->imap_delimiter, $folder);
+
+                                $mailService->addTo($data['input_to']);
+                                $mailService->addCc( $data['input_cc']);
+                                $mailService->addBcc($data['input_cco']);
+                                $mailService->setSubject($data['input_subject']);
+
+                                if(isset($data['input_important_message']))
+                                        $mailService->addHeaderField('Importance','High');
+
+                                if(isset($data['input_return_receipt']))
+                                        $mailService->addHeaderField('Disposition-Notification-To', Config::me('mail'));
+
+                                $isHTML = ( ( array_key_exists( 'type', $data ) && in_array( strtolower( $data[ 'type' ] ), array( 'html', 'plain' ) ) ) ? strtolower( $data[ 'type' ] ) != 'plain' : true );
+
+                                if (!$body) $body = ' ';
+                                
+
+                                $mbox_stream = $this->open_mbox($folder);
+
+                                $attachment = json_decode($data['attachments'],TRUE);
+                                
+
+                                foreach ($attachment as &$value) 
+                                {
+
+                                    if((int)$value > 0) //BD attachment
+                                    {
+                                         $att = Controller::read(array('id'=> $value , 'concept' => 'mailAttachment'));
+                                         
+                                         if($att['disposition'] == 'embedded')
+                                         {
+                                             $body = str_replace('"../prototype/getArchive.php?mailAttachment='.$att['id'].'"', $att['name'], $body);
+                                             $mailService->addStringImage(base64_decode($att['source']), $att['type'], $att['name']);
+                                         }
+                                         else
+                                             $mailService->addStringAttachment(base64_decode($att['source']), $att['name'], $att['type'], 'base64', isset($att['disposition']) ? $att['disposition'] :'attachment' );
+                                         
+                                         unset($att);
+                                    }
+                                    else //message attachment
+                                    {
+                                        $value = json_decode($value, true);
+                                        $sub =  $value['name'] ? $value['name'].'.eml' :'no title.eml';
+                                        $mbox_stream = $this->open_mbox($value['folder']);
+                                        $rawmsg = $this->getRawHeader($value['uid']) . "\r\n\r\n" . $this->getRawBody($value['uid']);
+                                        $mailService->addStringAttachment($rawmsg, $sub, 'message/rfc822', '7bit', 'attachment' );
+                                        unset($rawmsg);
+                                    }
+
+                                }
+                                
+                                if($isHTML) $mailService->setBodyHtml($body); else $mailService->setBodyText($body);
+                                                         
+                                if(imap_append($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, $mailService->getMessage(), "\\Seen \\Draft"))
+                                {
+                                    $status = imap_status($mbox_stream, "{".$this->imap_server.":".$this->imap_port."}".$folder, SA_UIDNEXT);
+                                    $return['id'] = $status->uidnext - 1;
+                                        
+                                    if($data['uidsSave'] )
+                                        $this->delete_msgs(array('folder'=> $folder , 'msgs_number' => $data['uidsSave']));
+                       
+                                }
+                 
+                                if($mbox_stream) imap_close($mbox_stream);
+                                
+                                
+                                
+                                return $return;
 			}
 		}
Index: /trunk/prototype/config/mailAttachment.ini
===================================================================
--- /trunk/prototype/config/mailAttachment.ini	(revision 5604)
+++ /trunk/prototype/config/mailAttachment.ini	(revision 5604)
@@ -0,0 +1,15 @@
+service = PostgreSQL
+PostgreSQL.concept = mail_attachment
+
+[before.create]
+encodeCreateAttachment = modules/mail/interceptors/Attachments.php
+
+[PostgreSQL.mapping]
+id = "id"
+source = "source"
+type = "type"
+name = "name"
+size = "size"
+owner = "owner"
+disposition = "disposition"
+dtstamp = "dtstamp"
Index: /trunk/prototype/modules/mail/interceptors/Attachments.php
===================================================================
--- /trunk/prototype/modules/mail/interceptors/Attachments.php	(revision 5604)
+++ /trunk/prototype/modules/mail/interceptors/Attachments.php	(revision 5604)
@@ -0,0 +1,23 @@
+<?php
+
+class Attachments {	
+	
+	public function encodeCreateAttachment( &$uri , &$params , &$criteria , $original ){
+                        
+		if(!isset($params['source'])) return false;
+		
+		if(isset($_FILES[$params['source']]))
+			if(isset($params['id']))
+				$params =  array_merge($_FILES[$params['source']], array('id' => $params['id']));
+			else
+				$params =  $_FILES[$params['source']];
+				
+                  $params['owner'] = Config::me('uidNumber'); 
+                                   
+                  $params['disposition'] = $original['properties']['disposition'];
+                  $params['dtstamp'] = time();
+	}
+  
+}
+
+?>
Index: /trunk/prototype/api/datalayer.js
===================================================================
--- /trunk/prototype/api/datalayer.js	(revision 5601)
+++ /trunk/prototype/api/datalayer.js	(revision 5604)
@@ -19,5 +19,7 @@
 
 	  if( isIframe.test( options.dataType ) || options.data instanceof FormData )
-	  {    
+	  {
+	      options.url = options.fileInput.parents( 'form' ).attr( 'action' );
+	    
 	      res = internalUrl.exec( options.url );
 
Index: /trunk/expressoMail1_2/index.php
===================================================================
--- /trunk/expressoMail1_2/index.php	(revision 5539)
+++ /trunk/expressoMail1_2/index.php	(revision 5604)
@@ -12,5 +12,5 @@
 	$GLOBALS['phpgw_info']['flags'] = array(
 		'noheader' => False,
-		'nonavbar' => False,
+		'nonavbar' => false,
 		'currentapp' => 'expressoMail1_2',
 		'enable_nextmatchs_class' => True
@@ -391,5 +391,7 @@
 <link rel='stylesheet' type='text/css' href='../prototype/modules/calendar/css/layout.css' />
 <link rel='stylesheet' type='text/css' href='../prototype/modules/calendar/css/style.css' />
-
+<link rel='stylesheet' type='text/css' href='../prototype/plugins/fileupload/jquery.fileupload-ui.css' />
+<script src="../prototype/plugins/fileupload/jquery.fileupload.js"></script>
+<script src="../prototype/plugins/fileupload/jquery.iframe-transport.js"></script>
 </body>
 </html>
Index: /trunk/expressoMail1_2/setup/tables_current.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/tables_current.inc.php	(revision 5603)
+++ /trunk/expressoMail1_2/setup/tables_current.inc.php	(revision 5604)
@@ -77,5 +77,5 @@
 			'ix' => array(),
 			'uc' => array()
-		)
+		
 	);
 ?>
Index: /trunk/expressoMail1_2/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 5557)
+++ /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 5604)
@@ -206,4 +206,27 @@
 		$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '2.4.1';
         return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
-	}	
+	}
+        $test[] = '2.4.1';
+	function expressoMail1_2_upgrade2_4_1() {
+            $oProc = $GLOBALS['phpgw_setup']->oProc;            
+            $oProc->CreateTable('mail_attachment',array(
+			'fd' => array(
+				'id' => array('type' => 'auto','nullable' => False),
+				'source' => array('type' => 'blob','nullable' => False),
+				'type' => array('type' => 'varchar','precision' => '50','nullable' => False),
+				'name' => array('type' => 'varchar','precision' => '255','nullable' => False),
+                                'disposition' => array('type' => 'varchar','precision' => '20','nullable' => true),
+				'size' => array('type' => 'int','precision' => '16','nullable' => False),
+                                'dtstamp' => array('type' => 'int','precision' => '16','nullable' => False),
+				'owner' => array('type' => 'int', 'precision' => '8','nullable' => True)
+			),
+			'pk' => array('id'),
+			'fk' => array(),
+			'ix' => array(),
+			'uc' => array()
+		)
+			);						
+		$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '2.4.2';
+        return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
+	}
 ?>
Index: /trunk/expressoMail1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/setup.inc.php	(revision 5547)
+++ /trunk/expressoMail1_2/setup/setup.inc.php	(revision 5604)
@@ -12,10 +12,11 @@
 	$setup_info['expressoMail1_2']['name']      	= 'expressoMail1_2';
 	$setup_info['expressoMail1_2']['title']     	= 'Expresso Mail';
-	$setup_info['expressoMail1_2']['version']   	= '2.4.1';
+	$setup_info['expressoMail1_2']['version']   	= '2.4.2';
 	$setup_info['expressoMail1_2']['app_order'] 	= 2;
 	$setup_info['expressoMail1_2']['tables'][]		= 'phpgw_expressomail_contacts';
     $setup_info['expressoMail1_2']['tables'][]		= 'phpgw_certificados';
 	
-	$setup_info['expressoMail1_2']['tables'][]		= 'expressomail_label';
+	$setup_info['expressoMail1_2']['tables'][]		= 'mail_attachment';
+        $setup_info['expressoMail1_2']['tables'][]		= 'expressomail_label';
 	$setup_info['expressoMail1_2']['tables'][]		= 'expressomail_followupflag';
 	$setup_info['expressoMail1_2']['tables'][]		= 'expressomail_message_followupflag';
